C  PROGRAM TO READ UNFORMATTED REGIONAL MODEL OUTPUT FLOWS AND TO WRITE
C  DATA FOR SUBREGIONAL BOUNDARY FLOWS IN FHB PACKAGE INPUT FILE.
C
C  STEADY-STATE VERSION
C
C  NODESR=NLAY*NROW*NCOL from regional model
C  ARRAY SIZING DEPENDS ON NUMBER OF RECORDS IN BNDFLX.DAT FILE
C  DO LOOP 15 COUNTER SIZED SIMILARLY
C  DO LOOP 100 COUNTER DEPENDS ON NUMBER OF COMPONENTS IN CELL-BY-CELL FILE
C ------------------------------------------------
c
c     RASA model 11 layers, 135 rows, 245 columns = 363825
      PARAMETER (NODESR=363825)
      REAL LF(NODESR)
      COMMON/DUMMY/FF,RF,LF,FLOW,KS,IS,JS,KR,IR,JR,IF,IDIV
      CHARACTER FLX*4,FI*4,LI*4,RI*4,TEXT(4)*4
      CHARACTER*40 PROMPT
      CHARACTER*80 FILNAM
      REAL FLOW(90000)
      INTEGER KS(90000),IS(90000),JS(90000),KR(90000),IR(90000)
      INTEGER JR(90000),IF(90000,3),IDIV(90000,3)
      integer izer,ifhbun,imin
      real zero,secday
      DIMENSION FF(NODESR),RF(NODESR)
      LOGICAL*1 T,F
      DATA FLX/'FLOW'/,FI/' FRO'/,RI/' RIG'/,LI/' LOW'/
       DATA T/.TRUE./,F/.FALSE./
      DATA PROMPT/'                                        '/
C
       OPEN(1,FILE='..\bndflx_dat.txt',STATUS='OLD')
C       OPEN(2,FILE='bndflx.fhb',STATUS='UNKNOWN')
C
C -----------READ UNFORMATTED FLUX FILE NAME-----------
C      PROMPT=' ENTER UNFORMATTED FILE NAME :'
C22    CALL ASFILE (3,N,PROMPT,T,FILNAM)
C      IF (N.EQ.0) GO TO 22

      print *,'Enter name of unfomatted flows output:'
      read(*,*) FILNAM
C      open(unit=3,file=filnam,status='OLD',FORM='UNFORMATTED')
      open(unit=3,file=filnam,FORM='UNFORMATTED',ACCESS='TRANSPARENT'
     2,status='OLD')


      print *,'Enter name FHB input file:'
      read(*,*) FILNAM
      OPEN(2,FILE=filnam,STATUS='UNKNOWN')


C
C --------READ SUBREGIONAL CELL FILE-------------
       DO 15 IJK=1,100000
       READ (1,*,END=18)KS(IJK),IS(IJK),JS(IJK),KR(IJK),IR(IJK),JR(IJK)
     +,IF(IJK,1),IDIV(IJK,1)
c      write(*,*)KS(IJK),IS(IJK),JS(IJK),KR(IJK),IR(IJK),JR(IJK)
c    +,IF(IJK,1),IDIV(IJK,1)
 17    FORMAT (12I5)
 15    CONTINUE
 18    NODECOUNT = IJK-1
C
       WRITE(*,425) nodecount
425    format (1X,'NODECOUNT=',I6)
C
 20    DO 50 I=1,NODECOUNT
       FLOW(I)=0.
       RF(I)=0.
       FF(I)=0.
  50   LF(I)=0.
       NUMWELLS = 0
C
      write(*,*) 'getting ready to read arrays'
      DO 100 M=1,8
c     READ(3,END=300) KSTP,KPER,TEXT,NCOL,NROW,NLAY
      READ(3,ERR=300) KSTP,KPER,TEXT,NCOL,NROW,NLAY
      WRITE(6,25) (TEXT(I),I=1,4),KSTP,KPER,NCOL,NROW,NLAY
  25    FORMAT(1X,'DATA BELOW WILL BE READ FOR     KSTP  KPER  NCOL NROW
     + NLAY',/,4A4,15X,2I6,1X,3I5)
C
       INDEX=0
       IF (TEXT(1).NE.FLX)READ (3) (TMP,I=1,NODESR)
       IF (TEXT(1).NE.FLX) GO TO 100
       IF (TEXT(2).EQ.RI) INDEX=1
       IF (TEXT(2).EQ.FI) INDEX=2
       IF (TEXT(2).EQ.LI) INDEX=3
       IF(INDEX.EQ.0) GO TO 100
      GO TO (101,102,103) INDEX
 101     READ (3) (RF(I),I=1,NODESR)
         write(*,*) 'Read RF array'
         GO TO 100
 102     READ (3) (FF(I),I=1,NODESR)
         write(*,*) 'Read FF array'
         GO TO 100
 103     READ (3)  (LF(I),I=1,NODESR)
         write(*,*) 'Read LF array'
100      CONTINUE
C
      write(*,*) 'getting ready to calculate flows'
      DO 200 IJK = 1,NODECOUNT
C ------------CALCULATE FLOWS-----------------
C  VARIABLE DEFINITIONS:
C     RL IS REGIONAL LAYER
C     RLA IS REGIONAL LAYER ABOVE
C     M IS CURRENT CELL
C     MB IS CELL BEHIND CURRENT CELL
C     ML IS CELL TO LEFT OF CURRENT CELL
C     MA IS CELL ABOVE CURRENT CELL
C
C  CELL FACE DEFINITIONS:
C             Modified to match MODPATH iface numbers OFR 94-464 p 3-9
C        ____
C       /    /|               1 is right face of cell to col at left
C      /__6_/ |<--4 (behind)  2 is (-1)*right face of current cell
C      |    | |               3 is front face of cell one row above
C     1| 3  |2/               4 is (-1)*front face of current cell
C      |____|/                6 is lower face of cell one lay above
C         5                   5 is (-1)*lower face of current cell
C ------------------------------------------------
       RL=((KR(IJK)-1)*(NCOL*NROW))
       RLA=((KR(IJK)-2)*NCOL*NROW)
       M=RL+((IR(IJK)-1)*NCOL)+JR(IJK)
       MB=RL+((IR(IJK)-2)*NCOL)+JR(IJK)
       ML=RL+((IR(IJK)-1)*NCOL)+JR(IJK)-1
       MA=RLA+((IR(IJK)-1)*NCOL)+JR(IJK)
c        write(*,*) ijk,if(ijk,1)
       DO 210 II=1,1
       IF (IF(IJK,II).EQ.0)GO TO 210
       IF (IF(IJK,II).EQ.1) FLOW(IJK)=FLOW(IJK)+(RF(ML)/IDIV(IJK,II))
       IF (IF(IJK,II).EQ.2) FLOW(IJK)=FLOW(IJK)+(-RF(M)/IDIV(IJK,II))
       IF (IF(IJK,II).EQ.4) FLOW(IJK)=FLOW(IJK)+(FF(MB)/IDIV(IJK,II))
       IF (IF(IJK,II).EQ.3) FLOW(IJK)=FLOW(IJK)+(-FF(M)/IDIV(IJK,II))
       IF (IF(IJK,II).EQ.6) FLOW(IJK)=FLOW(IJK)+(LF(MA)/IDIV(IJK,II))
       IF (IF(IJK,II).EQ.5) FLOW(IJK)=FLOW(IJK)+(-LF(M)/IDIV(IJK,II))
c       WRITE (*,99)IF(IJK,II),IDIV(IJK,II),FLOW(IJK)
99     FORMAT (2I5,F10.4)
       IF (FLOW(IJK).EQ. 0.0) GO TO 210
       NUMWELLS = NUMWELLS + 1
 210   CONTINUE
C
 200     CONTINUE
C
C ------------WRITE FHB INPUT FILE---------------
       nbdtim=1
       nhed=0
       ifhbss=0
       iun=53
       izer=0
       ifhbun=40
       imin=-1
       zero=0.0
       secday=86400.
       WRITE(2,110) nbdtim,NUMWELLS,nhed,ifhbss,iun,izer,izer,KPER
       write(2,110) ifhbun,nbdtim,imin
       write(2,112) zero
       write(2,113) ifhbun,secday,imin
       DO 240 I = 1,NODECOUNT
c       IF (FLOW(I) .EQ. 0.0) GO TO 240
       WRITE(2,111) KS(I),IS(I),JS(I),IF(I,1),FLOW(I)
 240   CONTINUE
 110   FORMAT(8I10)
 111   FORMAT (4I10,1x,E10.4)
 112   Format (f10.1)
 113   Format(i10,f10.1,i10)
       GO TO 20
C
 300   WRITE (6,55)
 55     FORMAT (2X,'  PROGRAM COMPLETE ' )
      STOP
      END

